{-# LANGUAGE RankNTypes #-}
module Control.Lens where

import           Control.Monad.Reader  (MonadReader, asks)
import           Data.Functor.Const    (Const (..))
import           Data.Functor.Identity (Identity (..))

type Lens s t a b = forall f. Functor f => (a -> f b) -> s -> f t

type Lens' s b = Lens s s b b

lens :: (s -> a) -> (s -> b -> t) -> Lens s t a b
lens sa sbt afb s = sbt s <$> afb (sa s)

type Getting r s a = (a -> Const r a) -> s -> Const r s

view :: MonadReader r m => Getting a r a -> m a
view l = asks (getConst . l Const)

type ASetter s t a b = (a -> Identity b) -> s -> Identity t

set :: ASetter s t a b -> b -> s -> t
set l b = runIdentity . l (\_ -> Identity b)
